﻿package MM
{
	
	import flash.display.MovieClip;
	import flash.display.Shape
	import flash.display.Graphics;
	import flash.events.*;
	import flash.text.*;
	
	import MM.UIButton;
	
	public class ButtonTimer extends MovieClip
	{
		private var obj:Shape;
		private var maskObj:Shape;
		private var numberText:TextField;
		private var radius:Number = 0;
		
		private var seconds:Number = 3;
		private var maxAngle:Number = 0;
		private var increm:Number = Math.PI/32;
		
		public var button:UIButton;
		
		public var buttonState:String = "inactive";
		
		
				
		public function ButtonTimer(inX:Number = 0, inY:Number = 0, rad:Number = 32, sec:Number = 3)
		{
			//trace("HI");

			obj = new Shape();//init the vars that are related to the sent vars
			obj.x = inX;
			obj.y = inY;

			seconds = sec;
			
			radius = rad;
			
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
			
		public function init(e:Event)
		{


			//trace("IT LIVES");//ButtonTimer has been added to the stage

			
			maskObj = new Shape();//init the others
			numberText = new TextField();
			increm = (2 * Math.PI) / (seconds * stage.frameRate);

			

			obj.graphics.lineStyle(1);//draw the circle to the object
			obj.graphics.beginFill(0x00FF00);
			obj.graphics.drawCircle(0,0,radius);
			obj.graphics.endFill();
			addChild(obj);

			maskObj.x = obj.x;//copy pos to the mask
			maskObj.y = obj.y;

			obj.mask = maskObj;//set mask
			addChild(maskObj);

			
			//addEventListener(Event.ENTER_FRAME, drawMask);
			//startMask();//start the mask

			numberText.x = obj.x;
			numberText.y = obj.y;
			numberText.visible = false;
			numberText.text = 0+"";
			addChild(numberText);
			
			

			
		}
		
		
		
		public function startMask()
		{
			if(buttonState == "inactive")
			{
				buttonState = "active";
				addEventListener(Event.ENTER_FRAME, drawMask);
			}
		}
		
		public function stopMask()
		{
			if(buttonState == "active")
			{
				buttonState = "inactive";
				removeEventListener(Event.ENTER_FRAME, drawMask);
				maskObj.graphics.clear();
				numberText.visible = false;
				
				//reset the countdown so that when the timer starts again, it will start anew
				maxAngle = 0;
				numberText.visible = false;
			}
		}

		public function drawMask(e:Event)
		{
			//trace("A");
			if(!numberText.visible)
			{
				numberText.visible = true;
			}
			//trace("A2");
			numberText.text = Math.ceil(seconds * (1 - (maxAngle / (2 * Math.PI))))+"";
			//trace("A3");
			maskObj.graphics.lineStyle(1);//redraw to first point
			maskObj.graphics.beginFill(0x000000);
			maskObj.graphics.moveTo(0,0);
			//trace("A4");
			for(var currAngle:Number = 0; currAngle <=maxAngle; currAngle += increm)
			{
				maskObj.graphics.lineTo(radius*Math.cos(currAngle), radius*Math.sin(currAngle));
				//trace(radius*Math.cos(currAngle) + " " + radius*Math.sin(currAngle));
			}
			//trace("A5");
			maskObj.graphics.lineTo(0,0);
			maskObj.graphics.endFill();
			//trace("A6");
			if(maxAngle >= 2*Math.PI)
			{
				finishMask();
			}
			else
			{
				//trace("A66");
				maxAngle += increm;
				//trace("A67");
			}
			//trace("A7");
		}
		
		public function finishMask()
		{
			if(buttonState == "active")
			{
				
				//change states
				buttonState = "standby";
				
				
				//tell the corresponding button to perform its action
				button.act();

				
				//clear the maskObj
				maskObj.graphics.clear();
				
				//reset the countdown so that when the timer starts again, it will start anew
				maxAngle = 0;
				numberText.visible = false;
				

				//stop drawing the mask
				removeEventListener(Event.ENTER_FRAME, drawMask);
				

			}
		}
		
		public function resetMask()
		{
			if(buttonState == "standby")
			{
				buttonState = "inactive";
			}
		}
			
			
	}
}