﻿package  {
	
	import uk.co.soulwire.cv.MotionTracker;
	
	/**
	 * I'm using Grant Skinners fantastic ColorMatrix class:
	 * http://www.gskinner.com/blog/archives/2007/12/colormatrix_upd.html
	 *
	 * And Justin Windle's MotionTracker (and MotionTrackerDemo as a guide)
	 */
	 
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.ColorMatrixFilter;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.geom.Point;
	 
	
	public class RemadeMotionTracking extends Sprite{
		
		private var _motionTracker : MotionTracker;
		private var _target : Point;
		private var _bounds : Shape;
		private var _output : Bitmap;
		private var _source : Bitmap;
		private var _video : BitmapData;
		private var _matrix : ColorMatrix;

		public function RemadeMotionTracking()
		{
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		public function init(e:Event)
		{
			setupTracking()
		}
		
		public function setupTracking()
		{
			//get the size for the display
			//we want this to be as large as the stage so it fills the entire "screen"
			var camW:int = stage.stageWidth;
			var camH:int = stage.stageHeight;
			
			//create the camera
			var cam:Camera = Camera.getCamera();
			cam.setMode(camW, camH, stage.frameRate);
			
			//setup the video object
			var vid:Video = new Video(camW, camH);
			vid.attachCamera(cam);
			
			//make Windle's MotionTracker
			_motionTracker = new MotionTracker(vid);
			
			//flip the input to get a mirror image for it to look right to the user
			_motionTracker.flipInput = true;
			
			//we're not bothering to display anything from this. We just want the data
			
			//setup the _target:Point to keep track of where the motion was
			_target = new Point(0,0);
			
			addEventListener(Event.ENTER_FRAME, update);
		}
		
		public function update(e:Event)
		{
			//get Windle's Motion Tracker to update itself
			_motionTracking.track();
			
			_target.x += (_motionTracker.x - _target.x) /10;
			_target.y += (_motionTracker.y - _target.y) /10;
		}

	}
	
}
