﻿package  {
	import flash.display.MovieClip;
	import fl.controls.DataGrid; 
	import fl.controls.dataGridClasses.DataGridColumn;
	import fl.controls.Label;
	import fl.data.DataProvider; 
	import fl.controls.Button;
	import fl.events.ListEvent;
	
	import flash.events.Event;
	import com.bit101.components.Label;
	import flash.text.*;
	import flash.events.DataEvent;
	import flash.events.MouseEvent;
	import MM.ButtonTimer;
	import flash.display.Sprite;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class StoreSelector extends MovieClip
	{
		
		public var aDg:DataGrid;
		public var storeName:String;
		public var storeID:String;
		public var storeInfo:Array = new Array(8);
		public var nameBox:TextField;
		public var storeModule:StoreWarsAvatarApp;
		//viewBox is used for the addition of all objects. This is how we can hide the objects in this save for the SWAApp
		public var viewBox:Sprite;
		
		public var stageHeight:Number = 480;
		public var stageWidth:Number = 900;

		public function StoreSelector()
		{
			
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		public function init(e:Event)
		{
			viewBox = new Sprite();
			//addChild(viewBox);
			//make the SWAApp and add it to the stage
			//don't worry about deactivating it. The SWAApp will do that itself
			storeModule = new StoreWarsAvatarApp();	
			addChild(storeModule);
			
			//set up screen
			
			//textbox for Store Selection
			var header:TextField = new TextField();
			header.text = "Store Selection";
			var format:TextFormat = new TextFormat("verdana", 32);
			header.setTextFormat(format);
			header.textColor = 0x00ff00;
			header.autoSize = TextFieldAutoSize.LEFT;
			viewBox.addChild(header);
			
			//set up the textField for the user to enter their name
			nameBox = new TextField();
			nameBox.type = TextFieldType.INPUT;
			nameBox.text = "EnterYourNameHere";
			nameBox.autoSize = TextFieldAutoSize.CENTER;
			var nameFormat:TextFormat = new TextFormat("verdana", 12, 0xffffff);
			nameBox.setTextFormat(nameFormat);
			
			viewBox.addChild(nameBox);
			
			
			//set up the DataGrid component for the selection options
			aDg = new DataGrid(); 
			viewBox.addChild(aDg); 
			//aDg.columns = [ "Store Name"]; 
			aDg.columns = [ "StoreName"]; 
			aDg.setSize(140, 100); 
			aDg.move(stageWidth/2 - aDg.width/2, stageHeight/2 - aDg.height/2);
			
			//set the position of the textfield (nameBox) for the user's name
			nameBox.x = stageWidth/2 - nameBox.width/2;
			nameBox.y = aDg.y - nameBox.height*2;
			
			
			//set the position of the title based on the datagrid
			header.x = stageWidth/2 - header.width/2;
			header.y = nameBox.y - header.height*2;
			
			//this will fire setupDatagrid when loaded and that will finish the init.
			//if this does not fire correctly, then the addObjectsToStage, which adds the viewbox to the stage, never happens and nothing will appear
			executePHP("users.php", setupDatagrid);
			
			/*
			//add items to the datagrid
			//these will be based on stores once I can get that data
			//use an array and set it is the data provider
			var dataArray:Array = new Array();
			//the data for an item must be in brackets
			//here, when we get the database, figure a way to grab all the storenames from the database and load it in here
			dataArray.push({StoreName:"A"}); 
			dataArray.push({StoreName:"B"}); 
			dataArray.push({StoreName:"C"}); 
			aDg.dataProvider = new DataProvider(dataArray);
			aDg.rowCount = aDg.length;
			aDg.addEventListener(ListEvent.ITEM_CLICK, setStoreName);
			//aDg.change = function(setStoreName);
			//aDg.addEventListener("change", setStoreName);*/
			
			//and add the Start button
			
			var startButton:Button = new Button();
			startButton.label = "Start SWAApp";
			startButton.width = 100;
			viewBox.addChild(startButton);
			startButton.move(stageWidth/2 - startButton.width/2, aDg.height + stageHeight/2 - startButton.height/2);
			startButton.addEventListener(MouseEvent.CLICK, startGame);
			
			
			
			
		}
		
		public function addObjectsToStage()
		{
			//this exists to allow the PHP to gather the user information and populate the store list before it ever appears on the screen
			addChild(viewBox);
		}
		
		public function startGame(e:Event)
		{
			if(storeName == null)
			{
				//I should make a popup for this or something...
				trace("Pick a store!");
			}
			else
			{
				/* use this sort of structure to load the xml for the store and then pass that to the SWAApp
				var xmlLoader:URLLoader = new URLLoader()
				xmlLoader.load(new URLRequest("interfaceIcons/imageXML.xml"));
				xmlLoader.addEventListener(Event.COMPLETE, processButtons);
				*/
				
				executePHP("users.php", openStorePart1);
				
				
				
			}
		}
		
		public function openStorePart1(e:Event)
		{
			//get the data from the event
			getUserData(e);
			//findItemCount(e);
			//use this data to open up the shop
			trace(storeInfo.toString());
			//storeModule.activation(storeID, nameBox.text, storeInfo);
			//deactivation();
			
			executePHP("floorObjects.php?uid="+storeID, openStorePart2);
		}
		
		public function openStorePart2(e:Event)
		{
			findItemCount(e);
			trace(storeInfo.toString());
			
			
			storeModule.activation(storeID, nameBox.text, storeInfo);
			deactivation();
			
		}
		
		public function setStoreName(e:ListEvent)
		{
			var o:Object = e.item;
			trace(o.StoreName);
			storeName = o.StoreName;
		}
		
		public function activation()
		{
			viewBox.visible = true;
		}
		
		public function deactivation()
		{
			viewBox.visible = false;
		}
		
		public function setupDatagrid(event:Event)
        {
                //create the XML object
                var myXML:XML = new XML(event.target.data);
				
				var dataArray:Array = new Array();
                
                //iterate through the user elements, within the users header
                for each(var xmlObject:XML in myXML.*)
                {
                        //add all the usernames into the datagrid
                        //userName = xmlObject.@name;
						
						//add items to the datagrid
						//use an array and set it is the data provider
						
						//the data for an item must be in brackets
						//here, when we get the database, figure a way to grab all the storenames from the database and load it in here
						dataArray.push({StoreName:xmlObject.@name}); 
						
						//aDg.change = function(setStoreName);
						//aDg.addEventListener("change", setStoreName);
                }
				
				aDg.dataProvider = new DataProvider(dataArray);
				//aDg.rowCount = aDg.length;
				aDg.rowCount = 5;
				aDg.addEventListener(ListEvent.ITEM_CLICK, setStoreName);
				
				addObjectsToStage();

		}
		
		public function findItemCount(e:Event)
		{
			
			var myXML:XML = new XML(e.target.data);
			//trace(myXML);
			for each(var xmlObject:XML in myXML.*)
			{
				//trace(xmlObject.@name);
				if(xmlObject.@name == "Dress Shirt")
				{
					storeInfo[1] = storeInfo[1] + 1;
				}
				
				if(xmlObject.@name == "Dress Pants")
				{
					storeInfo[3] = storeInfo[3] + 1;
				}
				
				if(xmlObject.@name == "Dress")
				{
					storeInfo[5] = storeInfo[5] + 1;
				}
				
				if(xmlObject.@name == "Skirt")
				{
					storeInfo[7] = storeInfo[7] + 1;
				}
				
				/*switch(xmlObject.@name)
				{
					case "Dress Shirt":
						trace("no");
						storeInfo[1] = storeInfo[1] + 1;
						break;
					case "Dress Pants":
						storeInfo[3] = storeInfo[3] + 1;
						break;
					case "Dress":
						storeInfo[5] = storeInfo[5] + 1;
						break;
					case "Skirt":
						storeInfo[7] = storeInfo[7] + 1;
						break;
				}*/
			}
		}
		
		//---------PHP STUFF-----------//
		
		public function executePHP(fileName:String, completeFunction:Function):void
        {
            //create the loader and request the php file
            var phpLoader:URLLoader = new URLLoader();
            phpLoader.load(new URLRequest("http://trudev.rit.edu/SWAApp/database/" + fileName));
            //listen for the COMPLETE event and call the completeFunction parameter
            phpLoader.addEventListener(Event.COMPLETE, completeFunction);
        }
		
		protected function getUserData(event:Event):void
        {
         		//throw("locateUser: " + event.target.data);
                //throw(new Error(event.target.data));
                //create the XML object
                var myXML:XML = new XML(event.target.data);
                
                
                
                //iterate through the user elements, within the users header
                for each(var xmlObject:XML in myXML.*)
                {
                    
                    //check the name attributes of this user tag
                    if(xmlObject.@name == storeName)
                    {
                        
                        //user has been located
                        //userName = xmlObject.@name;
                        storeID = xmlObject.@uid;
                        //userMoney = xmlObject.@money;
                        //updateBalance(0);
                        
                        //set season data
                       /* seasonIndex = xmlObject.@season;
                        switch(seasonIndex)
                        {
                            case 1:
                                season = "Winter";
                                break;
                            case 2:
                                season = "Spring";
                                break;
                            case 3:
                                season = "Summer";
                                break;
                            case 4:
                                season = "Fall";
                                break;
                            default:
                                season = "Winter";
                                break;
                        }*/
                        //set week data
                        //week = xmlObject.@week;
                        
                        //set pricing of objects on the floor
                        /*theFloor.productListing.dressShirtsPrice = theFloor.productListing.dressShirtsStepper.value = xmlObject.@dressShirtsPrice;
                        theFloor.productListing.dressPantsPrice = theFloor.productListing.dressPantsStepper.value = xmlObject.@dressPantsPrice;
                        theFloor.productListing.skirtsPrice = theFloor.productListing.skirtsStepper.value = xmlObject.@skirtsPrice;
                        theFloor.productListing.dressesPrice = theFloor.productListing.dressesStepper.value = xmlObject.@dressesPrice;*/
						storeInfo[0] = (xmlObject.@dressShirtsPrice);
						storeInfo[1] = (0);//the 0's are for the amount on the floor for this store. The next php will handle these
						storeInfo[2] = (xmlObject.@dressPantsPrice);
						storeInfo[3] = (0);
						storeInfo[4] = (xmlObject.@dressesPrice);
						storeInfo[5] = (0);
						storeInfo[6] = (xmlObject.@skirtsPrice);
						storeInfo[7] = (0);
                        
                        //set the bonus total
                       // bonusTotal = xmlObject.@bonusTotal;
                        
                        //turn tutorials off
                       // isNewUser = false;
                        
                        //retrieve floor setup
                       // executePHP("floorObjects.php?uid=" + userID, floorSetup);
                        
                        //begin polling for avatar stuff
                       // var enterTimer:Timer = new Timer(AVATAR_POLL_TIME, 0);
                       // enterTimer.start();
                        //enterTimer.addEventListener(TimerEvent.TIMER, avatarCheck);
                        
                        return;
                    }
                }

		}
	}
}
	

