﻿package {
	
	//import flash.display.*;
	import flash.display.MovieClip;
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.xml.*;
	
	import fl.controls.DataGrid;
	import fl.controls.dataGridClasses.DataGridColumn;
	import fl.data.DataProvider;
	
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.BitmapFileMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.objects.primitives.Sphere
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.MovieMaterial;
	import org.papervision3d.materials.special.CompositeMaterial;
	import org.papervision3d.objects.DisplayObject3D;
	
	
	import MM.ClothingContainer;
	import MM.ButtonTimer;
	import MM.UIButton;
	
	import ARMotionTracker;
	
	//[SWF(width=640, height=480, backgroundColor=0x808080, frameRate=30)]
	
	public class StoreWarsAvatarApp extends PV3DARApp {
		
		//-----ORIGINAL VARIABLES------//
		private var _plane:Plane;
		private var _cube:Cube;
		
		//-----NEW VARIABLES I ADDED----//
		private var clothingPlane:DisplayObject3D;
		private var material:BitmapFileMaterial;
		private var imgXML:XML;
		private var xmlPos:int = 0;
		private var motionTracking:ARMotionTracker;
		private var trackCircle:Sphere;
		
		//-----New Variables for SWAApp----//
		public var storeID:String;
		public var userName:String;
		public var buyList:DataGrid;
		public var dataArray:Array;
		public var storeData:Array;
		public var playerClothing:Array;
		
		public var stageHeight:Number = 480;
		public var stageWidth:Number = 900;
		
		public function StoreWarsAvatarApp(/*storeName:String, user:String*/) {
			//this needs to start out invisible
			visible = false;
			
			storeID = "No Store";
			userName = "Nobody";
			storeData = new Array();
			playerClothing = new Array();
			playerClothing.push("face");
			playerClothing.push("shirt");
			playerClothing.push("pants");
			//storeID = storeName;
			//trace("StoreName: " + storeID);
			//userName = user;
			//trace("UserName: " + userName);
			//storeData = inStore
			//trace(storeData); --777--
			
			// Initalize application with the path of camera calibration file and pattern definition file.
			// カメラ補正ファイルとパターン定義ファイルのファイル名を渡して初期化。
			addEventListener(Event.INIT, _onInit);
			init('Data/camera_para.dat', 'Data/tinkernut.pat');
		}
		
		private function _onInit(e:Event):void {
			// Create Plane with same size of the marker.
			// マーカーと同じサイズを Plane を作ってみる。
			var wmat:WireframeMaterial = new WireframeMaterial(0xff0000, 1, 2); // with wireframe. / ワイヤーフレームで。
			_plane = new Plane(wmat, 80, 80); // 80mm x 80mm。
			_plane.rotationX = 180;
			//_markerNode.addChild(_plane); // attach to _markerNode to follow the marker. / _markerNode に addChild するとマーカーに追従する。

			// Place the light at upper front.
			// ライトの設定。手前、上のほう。
			var light:PointLight3D = new PointLight3D();
			light.x = 1000;
			light.y = 1000;
			light.z = -1000;
			
			//---------ORIGINAL CODE-------//
			/*
			// Create Cube.
			// Cube を作る。
			var fmat:FlatShadeMaterial = new FlatShadeMaterial(light, 0xff22aa, 0x75104e); // Color is ping. / ピンク色。
			_cube = new Cube(new MaterialsList({all: fmat}), 40, 40, 40); // 40mm x 40mm x 40mm
			_cube.z = 20; // Move the cube to upper (minus Z) direction Half height of the Cube. / 立方体の高さの半分、上方向(-Z方向)に移動させるとちょうどマーカーにのっかる形になる。
			_markerNode.addChild(_cube);*/
			
			//--------MY CODE------------//
			
			//ideally get an image and place it where the marker is
			//populate the images array with URLRequests to each image in a specified folder
			//attach the image to the _markerNode and run from there
			
			
			// Set some colors so we can see if loading is still happening,
			// or if it failed
			BitmapFileMaterial.LOADING_COLOR = 0x0000FF;
			BitmapFileMaterial.ERROR_COLOR = 0xFF0000;
			
			
			
			//Set up a dummy plane and add it to the scene, not to the markerNode
			//Adding to markerNode gives it unwanted rotations
			//clothingPlane = new Plane();
			clothingPlane = new DisplayObject3D();
			_scene.addChild(clothingPlane);
			
			//set up the interface so that its ready to be used when the XML has finished loading.
			//interfacePrep();
			
			//load in the XML for the buttons
			//when I can, start off by loading an XML for the user with all their data. this will give us the amount of prices of their items for sale
			var xmlLoader:URLLoader = new URLLoader()
			xmlLoader.load(new URLRequest("interfaceIcons/imageXML.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, processButtons);
			
			//XML loading for the clothing will be called once the button processing has finished
			
			/*var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.load(new URLRequest("images/imageXML.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, processXML);*/
			
			//set up the datagrid that will act as the Checkout/Pending Purchase list
			dataArray = new Array();//this is the dataProvider for the dataGrid
			//dataArray.push({ItemName:"Ass", Price:"42", QuantityInCart:"None"});
			buyList = new DataGrid(); 
			//buyList.dataProvider = new DataProvider(dataArray);
			addChild(buyList); 
			//buyList.columns = [ "Store Name"]; 
			//buyList.columns = [ "ItemName", "Price", "QuantityInCart"]; 
			buyList.addColumn("ItemName");
			buyList.addColumn("Price");
			//buyList.addColumn("QuantityInCart");
			//buyList.rowCount = 1;
			buyList.setSize(stageWidth - 640, buyList.rowHeight +20);
			buyList.move(640,0);
	
			//the rest of the setup is in processButtons/processXML since setting up the plane requires the xml to be loaded
			
		}
		
		private var buttonXML:XML;
		private var xmlButtonPos:int = 0;
		
		function processButtons(e:Event):void 
		{
			buttonXML = new XML(e.target.data);
			//trace(buttonXML);
			//load the first image from file
			//material = new BitmapFileMaterial(imgXML.image[xmlPos]);
			material = new BitmapFileMaterial("interfaceIcons/" + buttonXML.button[0].URLs);
			
			//set up an event listener that will wait for when the image has been loaded and set the dimensions of the plane
			addEventListener(Event.ENTER_FRAME, setButtonDimensions);
			
		}
		
		//Variables for buttons
		private var nextButton:Plane;
		private var prevButton:Plane;
		private var buyButton:Plane;
		private var returnButton:Plane;
		private var likeButton:Plane;
		private var dislikeButton:Plane;
		
		private var nextButtonMaterial:BitmapFileMaterial;
		private var prevButtonMaterial:BitmapFileMaterial;
		private var buyButtonMaterial:BitmapFileMaterial;
		private var returnButtonMaterial:BitmapFileMaterial;
		private var likeButtonMaterial:BitmapFileMaterial;
		private var dislikeButtonMaterial:BitmapFileMaterial;
		
		
		
		
		private function setButtonDimensions(e:Event)
		{
			//this boolean is true after my variables in BitmapFileMaterial have been set
			//trace(material.dimensionsSet);
			if(material.dimensionsSet)
			{
				
				//this section will run multiple times before the program begins to set up all the planes
				//make a new plane and add it to the clothingPlane so that when clothingPlane moves, all planes will move accordingly
				var newPlane:UIButton = new UIButton(material, 32, 32, 5, 5, this);
				
				//set the Plane's name to be where its image was found in the XML plus B to denote it as an interface button
				newPlane.name = xmlButtonPos+"B";
				
				//set its purpose so it knows how to act when its timer ticks down
				newPlane.purpose = buttonXML.button[xmlButtonPos].purpose
				
				//newPlane.addEventListener(MouseEvent.CLICK, buttonClick)
				
				//newPlane.x = -100;
				//newPlane.y = -100;
				newPlane.z += 500;//due to how to camera is set up, images must be placed at +500z to be of a workable size
				//newPlane.z -= 5;
				
				switch(xmlButtonPos)//at +500z, the screen size is  450 by 330 (halves are 225 and 165)
				{
					/*case 0:
						newPlane.x = 175;
						newPlane.y = 115;
						break;
					case 1:
						newPlane.x = -100;
						newPlane.y = 115;
						break;
					case 2:
						newPlane.x = 175;
						break;
					case 3:
						newPlane.x = -100;
						break;
					case 4:
						newPlane.x = 175;
						newPlane.y = -115;
						break;
					case 5:
						newPlane.x = -100;
						newPlane.y = -115;
						break;
					default:
						break;*/
						
					case 0:
						newPlane.x = 225-16;
						newPlane.y = 115;
						break;
					case 1:
						newPlane.x = -(225-16);
						newPlane.y = 115;
						break;
					case 2:
						newPlane.x = 225-16;
						break;
					case 3:
						newPlane.x = -(225-16);
						break;
					case 4:
						newPlane.x = 225 - 16;
						newPlane.y = -115;
						break;
					case 5:
						newPlane.x = -(225-16);
						newPlane.y = -115;
						break;
					case 6:
						newPlane.x = 255/2 - 16;
						newPlane.y = 115;
						break;
					case 7:
						newPlane.x = -(255/2 - 16);
						newPlane.y = 115;
						break;
					default:
						break;
				}
				
				
				_scene.addChild(newPlane);
				
				//set up the timer
				var p:Point = convertPapervisionToFlash(new Point(newPlane.x, newPlane.y));
				newPlane.timer = new ButtonTimer(p.x, p.y, 32,1);
				newPlane.timer.button = newPlane;
				addChild(newPlane.timer);
				
				
				
				
				//we have advanced one in the list, so increment xmlButtonPos
				xmlButtonPos++;
				
				
				//we're done here, remove the event listerner so that while we switch the material, we don't get extra planes
				removeEventListener(Event.ENTER_FRAME, setButtonDimensions);
				
				
				//if we are not past the amount of instances in the xml, then give a call to start loading the next bitmapfile for the next plane
				if(xmlButtonPos < buttonXML.button.length())
				{
					trace("Loading Next");
					loadNextButton();
				}
				else
				{
					//set up an event listener that will act as a fake ENTER_FRAME event listener for all the planes
					//addEventListener(Event.ENTER_FRAME, fakeEventListener);
					
					//once this is done, load and process the XML for the clothing
					var xmlLoader:URLLoader = new URLLoader();
					xmlLoader.load(new URLRequest("images/storeXML.xml"));
					xmlLoader.addEventListener(Event.COMPLETE, processXML);
				}
			}
		}
		
		private function loadNextButton()
		{
			//assign the new material to the material variable
			material = new BitmapFileMaterial("interfaceIcons/" + buttonXML.button[xmlButtonPos].URLs);
			//add the listener to wait for the bitmap load to be complete and set up the plane
			addEventListener(Event.ENTER_FRAME, setButtonDimensions);
		}
			
		
		function processXML(e:Event):void 
		{
			//grab an xml from the database?
			imgXML = new XML(e.target.data);
			//trace(imgXML);
			//load the first image from file
			//material = new BitmapFileMaterial(imgXML.image[xmlPos]);
			material = new BitmapFileMaterial("images/" + imgXML.clothing[0].URLs);
			
			//set up an event listener that will wait for when the image has been loaded and set the dimensions of the plane
			addEventListener(Event.ENTER_FRAME, setDimensions);
			
			stage.addEventListener(MouseEvent.CLICK, _onClick);
		}
		
		private function followMarker(e:Event)
		{
			if(_markerNode.z > 0)
			{
				clothingPlane.copyPosition(_markerNode);
			}
			clothingPlane.rotationX = 0;
			clothingPlane.rotationY = 0;
			clothingPlane.rotationZ = 0;
		}
		
		private function setDimensions(e:Event)
		{
			//this boolean is true after my variables in BitmapFileMaterial have been set
			//trace(material.dimensionsSet);
			if(material.dimensionsSet)
			{
				
				//this section will run multiple times before the program begins to set up all the planes
				//make a new plane and add it to the clothingPlane so that when clothingPlane moves, all planes will move accordingly
				var newPlane:ClothingContainer = new ClothingContainer(material, material.imgWidth, material.imgHeight, 5, 5);
				
				
				//set the Plane's name to be where its image was found in the XML
				newPlane.name = xmlPos+"";
				
				
				//set the extra variables that define the piece of clothing
				newPlane.itemName = imgXML.clothing[xmlPos].Name;
				newPlane.price =  Number(imgXML.clothing[xmlPos].Price);//--777-- use the price from the XML
				//trace(newPlane.price);
				newPlane.sizes = imgXML.clothing[xmlPos].Sizes;
				newPlane.clothingType = imgXML.clothing[xmlPos].Type;
				//trace(newPlane.sizes);
				
				
				//as long as we're not at the 0th position, make each plane invisible.
				if(xmlPos != 0)
				{
					newPlane.visible = false;
				}
				
				
				clothingPlane.addChild(newPlane);
				
				
				//we have advanced one in the list, so increment xmlPos
				xmlPos++;
				
				
				//we're done here, remove the event listerner so that while we switch the material, we don't get extra planes
				removeEventListener(Event.ENTER_FRAME, setDimensions);
				
				
				//if we are not past the amount of instances in the xml, then give a call to start loading the next bitmapfile for the next plane
				if(xmlPos < imgXML.clothing.length())
				{
					trace("Loading Next");
					loadNext();
				}
				else
				{
					trace("Done Loading");
					//otherwise, set up the event listener to follow the markerNode and the click function
					addEventListener(Event.ENTER_FRAME, followMarker);
					stage.addEventListener(MouseEvent.CLICK, _onClick);
					//and reset the xmlPos to 0 so that it lines up with the image shown
					xmlPos = 0;
					
					//this method will set up everything else
					finishInit();
				}
			}
		}
		
		private var sphereRadius:Number;
		private var baseMat:BitmapFileMaterial;
		private var greenMat:ColorMaterial;
		private var redMat:ColorMaterial;
		public function finishInit()
		{
			//flip the screen to allow the program to be easier to use
			mirror = !mirror;
			
			// Setting up MotionTracking with a sphere on the screen that mimics that of the MTD
			motionTracking = new ARMotionTracker();
			motionTracking.visible = false;

			addChild(motionTracking);
			
			//make an object that will follow the circle shape in the MTD
			sphereRadius = 15;
			
			//make 4 textures
			//one that will hold the combination of materials we want to use
			var compMat:CompositeMaterial = new CompositeMaterial();
			//one that will be the base image
			baseMat = new BitmapFileMaterial("images/hand.jpg");
			//one that will serve as the green hue for a liked image
			greenMat = new ColorMaterial(0x00FF00);
			//and one that will work as red hue for a disliked image
			redMat = new ColorMaterial(0xFF0000);
			
			//set the alpha to half so we can see the baseMat when they do get added in
			greenMat.fillAlpha = .5;
			redMat.fillAlpha = .5;
			
			//add only the base to the composite
			compMat.addMaterial(baseMat);
			
			trackCircle = new Sphere(compMat, sphereRadius );
			trackCircle.z += 500;//for reasons currently unknown, ridiculous amounts must be added to the z for the sphere to be visible
			_scene.addChild(trackCircle);
			
			//set up an event listener that will match the _target from motionTracking to the trackCircle here
			addEventListener(Event.ENTER_FRAME, coordinateConversions);
			
			//set up an event listener that will check for collisions
			addEventListener(Event.ENTER_FRAME, collisionCheck);
			
			hideStore();
			
			
		}
		
		
		public function coordinateConversions(e:Event)
		{
			//first convert the x
			var xpercent:Number = (motionTracking._target.x / 302) -.5;//302 appears to be the farthest x point for the Motion Tracking program
			//trace("X: " + xpercent);
			trackCircle.x = xpercent*450; //450 is the "screen width" at +500 z
			//flip the signs of the coordinate since we flipped the image
			trackCircle.x *= -1;
			
			//then do y
			var ypercent:Number = (motionTracking._target.y /240) -.5;//240 appears to be the farthest y point for the Motion Tracking program
			//trace("Y: " +ypercent);
			trackCircle.y = ypercent*330;//330 is the "screen height" at +500 z
			//flip here too
			trackCircle.y *= -1;
			
			/*trace(motionTracking._target);
			//x from flash will be x minus the position of the bounds of where the target is minus half of the stagewidth
			trace(stageWidth);
			trace(stageHeight);
			trackCircle.x = motionTracking._target.x - (stageWidth/2);
			trackCircle.y = motionTracking._target.y - (stageHeight/2);*/
			
			//trace(trackCircle.x + " " + trackCircle.y + ": SPHERE")
			//trace(motionTracking._target.x + " " + motionTracking._target.y + ":MOTION TARGET");
			//trace(motionTracking._output.x + " " + motionTracking._output.y + "OUTPUT WINDOW");
			
			
			/*if(motionTracking._target.y > stageHeight/2)
			{
				trackCircle.y *= -1;
			}*/
		}
		
		
		public function collisionCheck(e:Event)
		{
			var currButton:UIButton = _scene.getChildByName("0B") as UIButton;
			for(var num:Number = 0; num < buttonXML.button.length(); num++)
			{
				currButton = _scene.getChildByName(num+"B") as UIButton;
				//check to see if they are colliding and make sure there isn't already a timer set
				if(currButton.distanceTo(trackCircle) <= sphereRadius + 20)//32 is the UIButton width
				{
					//trace("good....");
					currButton.timer.startMask();
				}
				//check to see if they aren't colliding and if there is a timer
				if(currButton.distanceTo(trackCircle) > sphereRadius + 20)
				{
					//trace("huh?");
					currButton.timer.stopMask();
					currButton.timer.resetMask();
				}
			}
		}
		
		private function convertPapervisionToFlash(p:Point):Point
		{
			var xChanged:Number = p.x;
			var yChanged:Number = p.y;
			
			xChanged = (xChanged/450) -.5; //convert to a percent that corresponds with the coordinate system. 450 is the screen width in papervision at +500z
			xChanged *= 640; //take the percent and multiply by the flash screen width
			xChanged *= -1; //flip the image
			
			//do the same for the y taking note that now we use the screen heights
			
			yChanged = (yChanged/330) -.5;
			yChanged *= 480;
			yChanged *= -1;
			
			return new Point(xChanged, yChanged);
		}

		var mod:Number = 15;
		var sprt:MovieClip = new MovieClip();
		private function _onClick(e:MouseEvent):void
		{
			trace(getCurrentPlane().itemName + " " + getCurrentPlane().clothingType);
			trace(storeID);
			
			 /* //SPRITE DRAWING TEST
				
				sprt.graphics.lineStyle(1);
				sprt.graphics.beginFill(0x00FF00);
				sprt.graphics.drawCircle(0,0,32);
				sprt.graphics.endFill();
				
//				sprt.z -=30;
				
				addChild(sprt);*/
				//trace("BS");
				
				/*var xpostochange:Number = 175;
				var xpercent:Number = (xpostochange / 450) -.5;//450 appears to be the farthest x point at +500z

				var xpos = xpercent*640; //640 is the screen width
				//flip the signs of the coordinate since we flipped the image
				xpos *= -1;
				
				var ypostochange:Number = 115;
				var ypercent:Number = (ypostochange / 330) -.5;//330 appears to be the farthest x point at +500z

				var ypos = ypercent*480; //640 is the screen width
				//flip the signs of the coordinate since we flipped the image
				ypos *= -1;
				
				var countdown:ButtonTimer = new ButtonTimer(xpos,ypos,32,3);
				
				addChild(countdown);*/
				/*var newObj:DisplayObject3D = _scene.getChildByName("0B");
				var newPlane:Plane = newObj as Plane;
				trace(newPlane);
				
				newPlane.materials = new MaterialsList();
				//trace(newPlane.materials + "HI");
				newPlane.materials.addMaterial(new MovieMaterial(sprt, true), "circle")
				//trace(newPlane.materials + "HI");*/
				
			
			
			//mirror = !mirror;
			/*nextImage();
			trace(trackCircle);
			trace(motionTracking._target.x  + " " + motionTracking._target.y);
			//trace(motionTracking._video.x + " " + motionTracking._video.y);
			trace(motionTracking._output.x  + " " + motionTracking._output.y);*/
		}
		
		public function getCurrentPlane()
		{
			return clothingPlane.getChildByName( xmlPos % imgXML.clothing.length() +"");
		}
		
		public function nextImage()
		{
			//--777-- for this and prev, run a php to make this item the current item
			//make the current plane invisible and the next one visible
			//clothingPlane.getChildByName( xmlPos % imgXML.clothing.length() +"").visible = false;
			getCurrentPlane().visible = false;
			
			//increment, make sure it wraps around if needed
			xmlPos++;
			if(xmlPos == imgXML.clothing.length())
			{
				xmlPos = 0;
			}
			
			//trace(xmlPos + " " + imgXML.clothing.length() + " " + ClothingContainer(clothingPlane.getChildByName( xmlPos % imgXML.clothing.length() +"")).price + " " + ClothingContainer(clothingPlane.getChildByName( xmlPos % imgXML.clothing.length() +"")).sizes);
			
			getCurrentPlane().visible = true;
			
			likeCheck();
			activeUpdate();
		}
		
		public function prevImage()
		{
			//make the current plane invisible and the next one visible
			getCurrentPlane().visible = false;
			
			//increment, make sure it wraps around if needed
			xmlPos--;
			if(xmlPos == -1)
			{
				xmlPos = imgXML.clothing.length()-1;
			}
			
			//trace(xmlPos + " " + imgXML.clothing.length() + " " + ClothingContainer(clothingPlane.getChildByName( xmlPos % imgXML.clothing.length() +"")).price + " " + ClothingContainer(clothingPlane.getChildByName( xmlPos % imgXML.clothing.length() +"")).sizes);
			
			getCurrentPlane().visible = true;
			
			likeCheck();
			activeUpdate();
		}
		
		public function activeUpdate()
		{
			executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace=face&avatarTop=top&avatarBottom=bottom&actionType=View&item="+
					   getCurrentPlane().itemName, dummyFunction);
		}
		
		public function dummyFunction(e:Event)
		{
			trace("XML Shtuff");
			trace(e.target.data);
			return;
		}
		
		public function buy()
		{
			var currPlane:ClothingContainer = getCurrentPlane();
			//--777-- only allow if there is at least 1 more than the amount in the list
			if(currPlane.amount >= this.storeData[xmlPos*2 + 1])
			{
				//this means that the amount we have is exactly (and hopefuly not more than) the amount on the floor
				trace("Not any left in the store");
				return;
			}
			currPlane.amount += 1;
			
			//add an instance of the currentPlane's name to the checkout list
			//additionally, if there are 0 of this item in the database, give something that says that you cannot buy it
			
			//buyList.columns = [ "ItemName", "Price", "QuantityInCart"]; 
			//dataArray.push({StoreName:"A"}); 
			
			//dataArray.push({ItemName:currPlane.itemName, Price:currPlane.price, QuantityInCart:1});
			//buyList.dataProvider = new DataProvider(dataArray);
			buyList.addItem({ItemName:currPlane.itemName, Price:currPlane.price/*, QuantityInCart:1*/});
			buyList.rowCount = buyList.length + 1;
			trace("Move to buying list");
			
		}
		
		public function giveBack()
		{
			//take an item off of the buy list
			//if the item doesn't exist, then just do nothing.
			
			var currPlane:ClothingContainer = getCurrentPlane();
			
			//find the first instance of the name of the current clothing plane and remove it.
			for(var i:int = 0; i < buyList.rowCount -1; i++)
			{
				var o:Object = buyList.getItemAt(i);
				if(o.ItemName == currPlane.itemName)
				{
					trace("Move off of buying list");
					currPlane.amount -= 1;
					buyList.removeItemAt(i);
					buyList.rowCount = buyList.length + 1;
					return;
				}
				//buyList.removeItemAt(i);
			}
			trace("This item was not in the cart");
		}
		
		public function like()
		{
			if(getCurrentPlane().like < 1)
			{
				getCurrentPlane().like = 1;
				executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace=face&avatarTop=top&avatarBottom=bottom&actionType=Like&item="+
					   getCurrentPlane().itemName, dummyFunction);
			}
			else
			{
				getCurrentPlane().like = 0;
				executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace=face&avatarTop=top&avatarBottom=bottom&actionType=Dislike&item="+
					   getCurrentPlane().itemName, dummyFunction);
			}
			
			likeCheck();
		}
		
		public function dislike()
		{
			if(getCurrentPlane().like > -1)
			{
				getCurrentPlane().like = -1;
				executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace=face&avatarTop=top&avatarBottom=bottom&actionType=Dislike&item="+
					   getCurrentPlane().itemName, dummyFunction);
			}
			else
			{
				getCurrentPlane().like = 0;
				executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace=face&avatarTop=top&avatarBottom=bottom&actionType=Like&item="+
					   getCurrentPlane().itemName, dummyFunction);
			}
			
			likeCheck();
		}
		
		public function likeCheck()
		{
			//get the composite material and remove everything and then reinsert the base
			var compMat:CompositeMaterial = trackCircle.material as CompositeMaterial;
			compMat.removeAllMaterials();
			compMat.addMaterial(baseMat);
			if(getCurrentPlane().like == 1)
			{
				compMat.addMaterial(greenMat);
			}
			else
			{
				if(getCurrentPlane().like == -1)
				{
					compMat.addMaterial(redMat);
				}
			}
		}
		
		public function goBack()
		{
			//deactivate this and activate the parent 
			deactivation();
			var firstScreen:StoreSelector = parent as StoreSelector;
			firstScreen.activation();
		}
		
		public function tryOn()
		{
			//execute a php to change the clothes of the avatar
			if(getCurrentPlane().clothingType == "top")
			{
				if(playerClothing[1] == getCurrentPlane().itemName)
				{
					playerClothing[1] = "shirt";
				}
				else
				{
					playerClothing[1] = getCurrentPlane().itemName;
				}
			}
			if(getCurrentPlane().clothingType == "bottom")
			{
				if(playerClothing[2] == getCurrentPlane().itemName)
				{
					playerClothing[2] = "pants";
				}
				else
				{
					playerClothing[2] = getCurrentPlane().itemName;
				}
			}
			executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace="+playerClothing[0]+"&avatarTop="+playerClothing[1]+"&avatarBottom="+playerClothing[2]+"&actionType=Change&item="+
					   getCurrentPlane().itemName, dummyFunction);
		}
				
		
		protected function loadNext()
		{
			//assign the new material to the material variable
			material = new BitmapFileMaterial("images/" + imgXML.clothing[xmlPos].URLs);
			//add the listener to wait for the bitmap load to be complete and set up the plane
			addEventListener(Event.ENTER_FRAME, setDimensions);
		}
		
		public function activation(storeName:String, user:String, inStore:Array) {
			
			storeID = storeName;
			userName = user;
			storeData = inStore;
			
			//for now, don't worry about reloading all of the images, but do this eventually.
			//this will require a restructuring of the initialization process of this class
			
			//reset the prices for all the items in the store
			//the order of the images in the clothing array will always be dressShirt, dressPants, dress, skirt
			var tempPlane:ClothingContainer;
			for(var i:int = 0; i < imgXML.clothing.length(); i++)
			{
				tempPlane = clothingPlane.getChildByName( i + "") as ClothingContainer;
				// snag the data from the storeData --777--
				tempPlane.price = storeData[i*2];
				
				//reset all the like values
				tempPlane.like = 0;
				likeCheck();
			}
			
			//make sure the program starts at the first plane
			xmlPos = 0;
			
			visible = true;
			addEventListener(Event.ENTER_FRAME, collisionCheck);
			
			//enter the store!
			executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace="+playerClothing[0]+"&avatarTop="+playerClothing[1]+"&avatarBottom="+playerClothing[2]+"&actionType=Enter&item="+
					   getCurrentPlane().itemName, dummyFunction);
		}
		
		public function deactivation()
		{
			
			//the actual deactivation code is in the leaveStore method. that will be called in the buyItemsInList()
			
			buyItemsInList();
			
		}
		
		
		public function buyItemsInList()
		{
			
			//this will go through the items in the datagrid and send a purchase script
			for(var i:int = 0; i < buyList.rowCount -1; i++)
			{
				var o:Object = buyList.getItemAt(i);
				if(i < buyList.rowCount -2)//this will do all but the last
				{
					
					trace("buying: " + o.ItemName);
					executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace=face&avatarTop=top&avatarBottom=bottom&actionType=Purchase&item="+
					   o.ItemName, dummyFunction);
				}
				else//on the last one, when it finishes, leave the store.
				{
					executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace=face&avatarTop=top&avatarBottom=bottom&actionType=Purchase&item="+
					   o.ItemName, leaveStore);
				}
			}
			
			if(i==0)//meaning that there were no items in the buylist
			{
				//just leave the store
				leaveStore(new Event("leaveStore"));
			}
		}
		
		public function leaveStore(e:Event)
		{
			trace("leaving");
			hideStore();
			
			executePHP("addCustomerAction.php?uid="+storeID+"&custName="+userName+"&customerID="+
					   0+"&avatarFace=face&avatarTop=top&avatarBottom=bottom&actionType=Leave&item="+
					   getCurrentPlane().itemName, dummyFunction);
		}
		
		public function hideStore()
		{
			visible = false;
			removeEventListener(Event.ENTER_FRAME, collisionCheck);
		}
		
		public function executePHP(fileName:String, completeFunction:Function):void
        {
            //create the loader and request the php file
            var phpLoader:URLLoader = new URLLoader();
            phpLoader.load(new URLRequest("http://trudev.rit.edu/SWAApp/database/" + fileName));
            //listen for the COMPLETE event and call the completeFunction parameter
            phpLoader.addEventListener(Event.COMPLETE, completeFunction);
        }
			
			
	}
}